#!/bin/perl

#use strict;
#use diagnostics;

# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl Data-ParseTable.t'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test::More qw{ no_plan };

#tests => 1;
BEGIN { use_ok('Data::ParseTable') };
#can_ok( 'Data::ParseTable', ('parse_table'));

#########################

# Insert your test code below, the Test::More module is use()ed here so read
# its man page ( perldoc Test::More ) for help writing this test script.


# Generic test text line arrays with different comment specifiers

my @field_sep = ("\t", "  ", "&", "|",',');
my @comment = ("%","#","//");

foreach my $cm (@comment){
    foreach my $fs (@field_sep){
	
	my $line0 = "$cm" . " This is just a comment " . "$fs" . "Ignore \n";
	my $line1 = "head1" . "$fs" . "head2" . "$fs" . "head3\n";
	my $line2 = "$cm" . " This is also a comment \n";
	my $line3 = "1-1" . "$fs" . "1-2" . "$fs" . "1-3\n";
	my $line4 = "2-1" . "$fs" . "2-2" . "$fs" . "2-3\n";


	my @data_lines = ( 
			   "$line0",
			   "$line1",
			   "$line2",
			   "$line3",
			   "$line4",
			   );

	my @true_array = ( {head1 => '1-1',
			    head2 => '1-2',
			    head3 => '1-3',
			}, 
			   { head1 => '2-1',
			     head2 => '2-2',
			     head3 => '2-3',
			 });

	my %true_hash = (
			 head1 => [ '1-1', '2-1' ],
			 head2 => [ '1-2', '2-2' ],
			 head3 => [ '1-3', '2-3' ],
			 );
    

	my $result_array_ref = Data::ParseTable::parse_table( \@data_lines , { comment => "$cm" } );
	
	my $result_hash_ref = Data::ParseTable::parse_table( \@data_lines, 
							     { comment => "$cm", return_as_hash => 1 } );
	
	for my $line_no (0 .. $#data_lines-1){  
	    while ( my ($header, $value) = each %{$true_array[$line_no]}){
		is( $value , $result_array_ref->[$line_no]->{$header} , 
		    "Array test for $fs and $cm"  
);
	    }
	}
	
	foreach my $header (keys %true_hash){
	    for my $line_no (0 .. $#data_lines-1){
		is( $true_hash{$header}->[$line_no] , $result_hash_ref->{$header}->[$line_no], 
		    "Hash test for $fs and $cm" );
	    }
	}
    }
}

# confirm that we croak if the comment is a possible separator

my $cm = "&";
my $fs = ",";

my $line0 = "$cm" . " This is just a comment " . "$fs" . "Ignore \n";
my $line1 = "head1" . "$fs" . "head2" . "$fs" . "head3\n";
my $line2 = "$cm" . " This is also a comment \n";
my $line3 = "1-1" . "$fs" . "1-2" . "$fs" . "1-3\n";
my $line4 = "2-1" . "$fs" . "2-2" . "$fs" . "2-3\n";

my @data_lines = (
		  "$line0",
		  "$line1",
		  "$line2",
		  "$line3",
		  "$line4",
		  );



ok( not ($@) , "Should be Clean before test.\n");
eval{
    my $result_array_ref = Data::ParseTable::parse_table( \@data_lines , { comment => "$cm" } ); 
};   
ok( ($@) , "Should Croak successfully \n");

