#!/bin/perl

#use strict;
#use diagnostics;

# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl Data-ParseTable.t'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test::More qw{ no_plan };

#tests => 1;
BEGIN { use_ok('Data::ParseTable') };
#can_ok( 'Data::ParseTable', ('parse_table'));
use Data::Dumper;

#########################

# Insert your test code below, the Test::More module is use()ed here so read
# its man page ( perldoc Test::More ) for help writing this test script.

# binary fits
my $return_hash_ref = Data::ParseTable::parse_table('t/multi-dim.fits',
						    {return_as_hash => 1});

ok( abs($return_hash_ref->{r}[2]->at(1) -  179.1693572) < 1e-6);
ok( abs($return_hash_ref->{r}[6]->at(0) -  421.5978393) < 1e-6);

my $return_array_ref = Data::ParseTable::parse_table('t/multi-dim.fits',
						    {return_as_hash => 0});

ok( abs($return_array_ref->[2]{r}->at(1) -  179.1693572) < 1e-6);
ok( abs($return_array_ref->[6]{r}->at(0) -  421.5978393) < 1e-6);

my $tough_hash_ref = Data::ParseTable::parse_table('t/multi.fits',
						   {return_as_hash => 1});
ok( $tough_hash_ref->{aperture}[0] eq 'LARGE' );
ok( abs($tough_hash_ref->{net}[0]->at(3) - -12.0520420) < 1e-6 );

my $tough_array_ref = Data::ParseTable::parse_table('t/multi.fits',
						   {return_as_hash => 0});
ok( $tough_array_ref->[0]{aperture} eq 'LARGE' );
ok( abs($tough_array_ref->[0]{net}->at(3) - -12.0520420) < 1e-6 );

# Test that we can get a FITS table with PDL columns
my $pdl_hash_ref = Data::ParseTable::parse_table('t/multi-dim.fits',
						    {return_as_hash => 1,
						     return_as_pdl  => 1,
						    });
ok ($pdl_hash_ref->{net_rate}->nelem() == 13);
