#!/usr/bin/env /proj/axaf/bin/perlwrap

use warnings;

use PDL;
use PDL::NiceSlice;
use Data::Dumper;

use lib 'blib/lib';
use Ska::HashTable;

$src = Ska::HashTable->new("multi_d_col.fits");
$src->print;

$aipr = new Ska::HashTable 'aipr.fits.gz';
$aipr->set_format('sim_mode'=>'%10s', avg_ra => '%10.1f', 'avg_dec' , stop_time => '%13.2f');

$aipr0 = $aipr->row("obsid == 4421  && aspect_mode eq 'KALMAN' && aspect_mode =~ /kalm/i"); # 
$aipr0->print(qw(sim_mode avg_ra stop_time avg_dec));

print "Testing accessors:\n";
print "Avg_ra column: ",$aipr0->avg_ra, "\n";
print "aipr0.avg_ra(5)    : ",$aipr0->avg_ra(5), "\n";
print "aipr.avg_ra(5)     : ",$aipr->avg_ra(5), "\n";

$aipr0->print(sim_mode => '%8s', avg_ra => '%10.4f', avg_dec => '%10.4f', stop_time => '%13.2f');
$aipr0->print;
$aipr0->set_format('sim_mode'=>'%10s', avg_ra => '%10.1f', 'avg_dec' , stop_time => '%13.2f');
$aipr0->add_col('new_dec' => $aipr0->col('avg_dec') * -10.0, {new_dec => '%10.1f'});
$aipr0->print;
$aipr0->del_col('new_dec');
$aipr0->print;


$a = $aipr->row("obsid == 4421 && aspect_mode eq 'KALMAN'");
print $a->col("start_time");

$i = $aipr->row_index("obsid == 4421 && aspect_mode eq 'KALMAN'");
print $i;

$a = $aipr->row("obsid == 4421 && obsid==10 && aspect_mode eq 'KALMAN'");
print $a->col("start_time"), "\n";
print @{$a->col("aspect_mode")}, "\n";
print $a->is_pdl("start_time"), "\n";
print $a->is_pdl("aspect_mode"), "\n";

$stats = new Ska::HashTable 'stats.rdb';
$stats->print;
print $stats->col('med_dz') * 2;

$stats = new Ska::HashTable 'stats.dat';
$stats->print;
