# -*- perl -*-
# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl Ska-Process.t'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test::More tests => 2;
BEGIN { use_ok('Ska::Process') };
use Ska::Process qw(get_archive_files);

#########################

# Insert your test code below, the Test::More module is use()ed here so read
# its man page ( perldoc Test::More ) for help writing this test script.

# Got following on test, which seems like some bad interaction between Test::More
#  and Expect or whatever, since the code works just fine using
#  perl -I blib/lib archive.t
#
# Use of uninitialized value in ioctl at /proj/axaf/pkgs/perl-5.8.2/lib/site_perl/5.8.2/sun4u-solaris-thread-multi/IO/Pty.pm line 119.
# warning: TIOCSCTTY failed, slave might not be set as controlling terminal: Invalid argument at /proj/axaf/pkgs/perl-5.8.2/lib/site_perl/5.8.2/sun4u-solaris-thread-multi/IO/Pty.pm line 120.

$work_dir = $ENV{PWD};
$obsid = 819;
@obspar = get_archive_files(obsid     => $obsid,
			    prod      => "obspar",
			    file_glob => "axaf*obs0a.par*",
			    dir       => $work_dir,
			    loud      => 0,
			   );

@fidpr = get_archive_files(obsid     => $obsid,
			    prod      => "asp1[*fidpr*]",
			    file_glob => "pcad*fidpr*fits*",
			    version   => [3,2,1],
			    gunzip    => 1,
			    loud      => 0,
			   );

ok( @obspar && @fidpr );

unlink @obspar, @fidpr;
