#!/usr/bin/env perl

use warnings;
use strict;

use Getopt::Long;
use Astro::Cosmology;
use PDL;

my %opt = (lambda => 0.73,
	   matter => 0.27,
	   h0     => 71,
	  );

GetOptions(\%opt,
	   'lambda=f',
	   'matter=f',
	   'h0=f',
	   'redshift=f',
	   'flux=f',
	  )
  or die "ERROR - could not get options\n";

my $cosmo = Astro::Cosmology->new(map {$_ => $opt{$_}} qw(lambda matter h0));

print $cosmo->luminosity( $opt{flux}, $opt{redshift});


